diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/reconstruction.h svn/extern/libmv/libmv/simple_pipeline/reconstruction.h
--- trunk/extern/libmv/libmv/simple_pipeline/reconstruction.h	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/reconstruction.h	2013-09-14 11:24:31.000000000 +0100
@@ -21,6 +21,8 @@
 #ifndef LIBMV_SIMPLE_PIPELINE_RECONSTRUCTION_H_
 #define LIBMV_SIMPLE_PIPELINE_RECONSTRUCTION_H_
 
+#include <vector>
+
 #include "libmv/base/vector.h"
 #include "libmv/numeric/numeric.h"
 
@@ -38,21 +40,28 @@
 };
 
 /*!
-    A EuclideanCamera is the location and rotation of the camera viewing \a image.
+    A EuclideanView is the location and orientation of a camera viewing an
+    \a image. A EuclideanView may be associated with a particular \a camera for
+    a multicamera reconstruction. All EuclideanViews for the same \a camera
+    represent the motion of a particular video camera across all of its
+    corresponding images.
 
-    \a image identify which image from \l Tracks this camera represents.
-    \a R is a 3x3 matrix representing the rotation of the camera.
+    \a image identify which image from \l Tracks this view represents.
+    \a R is a 3x3 matrix representing the rotation of the view.
     \a t is a translation vector representing its positions.
+    \a camera identify which camera from \l Tracks this view is associated with.
 
     \sa Reconstruction
 */
-struct EuclideanCamera {
-  EuclideanCamera() : image(-1) {}
-  EuclideanCamera(const EuclideanCamera &c) : image(c.image), R(c.R), t(c.t) {}
+struct EuclideanView {
+  EuclideanView() : image(-1), camera(0) {}
+  EuclideanView(const EuclideanView &v)
+      : image(v.image), R(v.R), t(v.t), camera(v.camera) {}
 
   int image;
   Mat3 R;
   Vec3 t;
+  int camera;
 };
 
 /*!
@@ -71,16 +80,16 @@
 };
 
 /*!
-    The EuclideanReconstruction class stores \link EuclideanCamera cameras
+    The EuclideanReconstruction class stores \link EuclideanView views
     \endlink and \link EuclideanPoint points \endlink.
 
     The EuclideanReconstruction container is intended as the store of 3D
     reconstruction data to be used with the MultiView API.
 
-    The container has lookups to query a \a EuclideanCamera from an \a image or
-    a \a EuclideanPoint from a \a track.
+    The container has lookups to query a \a EuclideanView for an \a image, or a
+    \a EuclideanPoint from a \a track.
 
-    \sa Camera, Point
+    \sa View, Point
 */
 class EuclideanReconstruction {
  public:
@@ -93,16 +102,20 @@
   EuclideanReconstruction &operator=(const EuclideanReconstruction &other);
 
   /*!
-      Insert a camera into the set. If there is already a camera for the given
-      \a image, the existing camera is replaced. If there is no camera for the
-      given \a image, a new one is added.
+      Insert a view into the set. If there is already a view for the given
+      \a image, the existing view is replaced. If there is no view for the given
+      \a image, a new one is added. A view may be associated with a \a camera
+      in a multicamera reconstruction.
 
-      \a image is the key used to retrieve the cameras with the other methods
-      in this class.
+      \a image and \a camera are the keys used to retrieve the views with the
+      other methods in this class.
 
-      \note You should use the same \a image identifier as in \l Tracks.
+      \note You should use the same \a camera and \a image identifiers as in
+            \l Tracks.
+      \note All markers for a single \a image should have the same \a camera
+            identifiers.
   */
-  void InsertCamera(int image, const Mat3 &R, const Vec3 &t);
+  void InsertView(int image, const Mat3 &R, const Vec3 &t, int camera = 0);
 
   /*!
       Insert a point into the reconstruction. If there is already a point for
@@ -116,12 +129,15 @@
   */
   void InsertPoint(int track, const Vec3 &X);
 
-  /// Returns a pointer to the camera corresponding to \a image.
-  EuclideanCamera *CameraForImage(int image);
-  const EuclideanCamera *CameraForImage(int image) const;
+  /// Returns a pointer to the view corresponding to \a image.
+  EuclideanView *ViewForImage(int image);
+  const EuclideanView *ViewForImage(int image) const;
+
+  /// Returns all views for all images.
+  vector<EuclideanView> AllViews() const;
 
-  /// Returns all cameras.
-  vector<EuclideanCamera> AllCameras() const;
+  /// Returns all views for a particular \a camera.
+  vector<EuclideanView> AllViewsForCamera(int camera) const;
 
   /// Returns a pointer to the point corresponding to \a track.
   EuclideanPoint *PointForTrack(int track);
@@ -131,24 +147,31 @@
   vector<EuclideanPoint> AllPoints() const;
 
  private:
-  vector<EuclideanCamera> cameras_;
+  vector<EuclideanView> views_;
   vector<EuclideanPoint> points_;
 };
 
 /*!
-    A ProjectiveCamera is the projection matrix for the camera of \a image.
+    A ProjectiveView is the projection matrix for the view of an \a image. A
+    ProjectiveView may be associated with a particular \a camera for a
+    multicamera reconstruction. All ProjectiveViews for the same \a camera
+    represent the motion of a particular video camera across all of its
+    corresponding images.
 
-    \a image identify which image from \l Tracks this camera represents.
+    \a image identify which image from \l Tracks this view represents.
     \a P is the 3x4 projection matrix.
+    \a camera identify which camera from \l Tracks this view is associated with.
 
     \sa ProjectiveReconstruction
 */
-struct ProjectiveCamera {
-  ProjectiveCamera() : image(-1) {}
-  ProjectiveCamera(const ProjectiveCamera &c) : image(c.image), P(c.P) {}
+struct ProjectiveView {
+  ProjectiveView() : image(-1), camera(0) {}
+  ProjectiveView(const ProjectiveView &v)
+      : image(v.image), P(v.P), camera(v.camera) {}
 
   int image;
   Mat34 P;
+  int camera;
 };
 
 /*!
@@ -167,30 +190,34 @@
 };
 
 /*!
-    The ProjectiveReconstruction class stores \link ProjectiveCamera cameras
+    The ProjectiveReconstruction class stores \link ProjectiveView views
     \endlink and \link ProjectivePoint points \endlink.
 
     The ProjectiveReconstruction container is intended as the store of 3D
     reconstruction data to be used with the MultiView API.
 
-    The container has lookups to query a \a ProjectiveCamera from an \a image or
+    The container has lookups to query a \a ProjectiveView for an \a image, or
     a \a ProjectivePoint from a \a track.
 
-    \sa Camera, Point
+    \sa View, Point
 */
 class ProjectiveReconstruction {
  public:
   /*!
-      Insert a camera into the set. If there is already a camera for the given
-      \a image, the existing camera is replaced. If there is no camera for the
-      given \a image, a new one is added.
+      Insert a view into the set. If there is already a view for the given
+      \a image, the existing view is replaced. If there is no view for the given
+      \a image, a new one is added. A view may be associated with a \a camera
+      in a multicamera reconstruction.
 
-      \a image is the key used to retrieve the cameras with the other methods
-      in this class.
+      \a image and \a camera are the keys used to retrieve the views with the
+      other methods in this class.
 
-      \note You should use the same \a image identifier as in \l Tracks.
+      \note You should use the same \a camera and \a image identifiers as in
+            \l Tracks.
+      \note All markers for a single \a image should have the same \a camera
+            identifiers.
   */
-  void InsertCamera(int image, const Mat34 &P);
+  void InsertView(int image, const Mat34 &P, int camera = 0);
 
   /*!
       Insert a point into the reconstruction. If there is already a point for
@@ -204,12 +231,15 @@
   */
   void InsertPoint(int track, const Vec4 &X);
 
-  /// Returns a pointer to the camera corresponding to \a image.
-  ProjectiveCamera *CameraForImage(int image);
-  const ProjectiveCamera *CameraForImage(int image) const;
+  /// Returns a pointer to the view corresponding to \a image.
+  ProjectiveView *ViewForImage(int image);
+  const ProjectiveView *ViewForImage(int image) const;
+
+  /// Returns all views.
+  vector<ProjectiveView> AllViews() const;
 
-  /// Returns all cameras.
-  vector<ProjectiveCamera> AllCameras() const;
+  /// Returns all views for a particular \a camera.
+  vector<ProjectiveView> AllViewsForCamera(int camera) const;
 
   /// Returns a pointer to the point corresponding to \a track.
   ProjectivePoint *PointForTrack(int track);
@@ -219,7 +249,7 @@
   vector<ProjectivePoint> AllPoints() const;
 
  private:
-  vector<ProjectiveCamera> cameras_;
+  vector<ProjectiveView> views_;
   vector<ProjectivePoint> points_;
 };
 
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/reconstruction_scale.cc svn/extern/libmv/libmv/simple_pipeline/reconstruction_scale.cc
--- trunk/extern/libmv/libmv/simple_pipeline/reconstruction_scale.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/reconstruction_scale.cc	2013-09-14 12:00:11.000000000 +0100
@@ -24,37 +24,37 @@
 namespace libmv {
 
 void EuclideanScaleToUnity(EuclideanReconstruction *reconstruction) {
-  vector<EuclideanCamera> all_cameras = reconstruction->AllCameras();
+  vector<EuclideanView> all_views = reconstruction->AllViews();
   vector<EuclideanPoint> all_points = reconstruction->AllPoints();
 
-  // Calculate center of the mass of all cameras.
-  Vec3 cameras_mass_center = Vec3::Zero();
-  for (int i = 0; i < all_cameras.size(); ++i) {
-    cameras_mass_center += all_cameras[i].t;
+  // Calculate center of the mass of all views.
+  Vec3 views_mass_center = Vec3::Zero();
+  for (int i = 0; i < all_views.size(); ++i) {
+    views_mass_center += all_views[i].t;
   }
-  cameras_mass_center /= all_cameras.size();
+  views_mass_center /= all_views.size();
 
-  // Find the most distant camera from the mass center.
+  // Find the most distant view from the mass center.
   double max_distance = 0.0;
-  for (int i = 0; i < all_cameras.size(); ++i) {
-    double distance = (all_cameras[i].t - cameras_mass_center).squaredNorm();
+  for (int i = 0; i < all_views.size(); ++i) {
+    double distance = (all_views[i].t - views_mass_center).squaredNorm();
     if (distance > max_distance) {
       max_distance = distance;
     }
   }
 
   if (max_distance == 0.0) {
-    LG << "Cameras position variance is too small, can not rescale";
+    LG << "Views position variance is too small, can not rescale";
     return;
   }
 
   double scale_factor = 1.0 / sqrt(max_distance);
 
-  // Rescale cameras positions.
-  for (int i = 0; i < all_cameras.size(); ++i) {
-    int image = all_cameras[i].image;
-    EuclideanCamera *camera = reconstruction->CameraForImage(image);
-    camera->t = camera->t * scale_factor;
+  // Rescale views positions.
+  for (int i = 0; i < all_views.size(); ++i) {
+    int image = all_views[i].image;
+    EuclideanView *view = reconstruction->ViewForImage(image);
+    view->t = view->t * scale_factor;
   }
 
   // Rescale points positions.
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/resect.cc svn/extern/libmv/libmv/simple_pipeline/resect.cc
--- trunk/extern/libmv/libmv/simple_pipeline/resect.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/resect.cc	2013-09-14 11:24:31.000000000 +0100
@@ -183,7 +183,7 @@
 
   LG << "Resection for image " << markers[0].image << " got:\n"
      << "R:\n" << R << "\nt:\n" << t;
-  reconstruction->InsertCamera(markers[0].image, R, t);
+  reconstruction->InsertView(markers[0].image, R, t, markers[0].camera);
   return true;
 }
 
@@ -273,7 +273,7 @@
 
   LG << "Resection for image " << markers[0].image << " got:\n"
      << "P:\n" << P;
-  reconstruction->InsertCamera(markers[0].image, P);
+  reconstruction->InsertView(markers[0].image, P, markers[0].camera);
   return true;
 }
 }  // namespace libmv
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/tracks.cc svn/extern/libmv/libmv/simple_pipeline/tracks.cc
--- trunk/extern/libmv/libmv/simple_pipeline/tracks.cc	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/tracks.cc	2013-09-14 11:24:31.000000000 +0100
@@ -23,6 +23,7 @@
 #include <algorithm>
 #include <vector>
 #include <iterator>
+#include <cstdio>
 
 #include "libmv/numeric/numeric.h"
 
@@ -34,7 +35,7 @@
 
 Tracks::Tracks(const vector<Marker> &markers) : markers_(markers) {}
 
-void Tracks::Insert(int image, int track, double x, double y) {
+void Tracks::Insert(int image, int track, double x, double y, int camera) {
   // TODO(keir): Wow, this is quadratic for repeated insertions. Fix this by
   // adding a smarter data structure like a set<>.
   for (int i = 0; i < markers_.size(); ++i) {
@@ -45,7 +46,7 @@
       return;
     }
   }
-  Marker marker = { image, track, x, y };
+  Marker marker = { image, track, x, y, camera };
   markers_.push_back(marker);
 }
 
@@ -73,12 +74,23 @@
   return markers;
 }
 
+vector<Marker> Tracks::MarkersForCamera(int camera) const {
+  vector<Marker> markers;
+  for (int i = 0; i < markers_.size(); ++i) {
+    if (camera == markers_[i].camera) {
+      markers.push_back(markers_[i]);
+    }
+  }
+  return markers;
+}
+
 vector<Marker> Tracks::MarkersInBothImages(int image1, int image2) const {
   vector<Marker> markers;
   for (int i = 0; i < markers_.size(); ++i) {
     int image = markers_[i].image;
-    if (image == image1 || image == image2)
+    if (image == image1 || image == image2) {
       markers.push_back(markers_[i]);
+    }
   }
   return markers;
 }
@@ -118,14 +130,25 @@
 
 Marker Tracks::MarkerInImageForTrack(int image, int track) const {
   for (int i = 0; i < markers_.size(); ++i) {
-    if (markers_[i].image == image && markers_[i].track == track) {
+    if (markers_[i].image == image &&
+        markers_[i].track == track) {
       return markers_[i];
     }
   }
-  Marker null = { -1, -1, -1, -1 };
+  Marker null = { -1, -1, -1, -1, -1 };
   return null;
 }
 
+void Tracks::RemoveMarkersInImage(int image) {
+  int size = 0;
+  for (int i = 0; i < markers_.size(); ++i) {
+    if (markers_[i].image != image) {
+      markers_[size++] = markers_[i];
+    }
+  }
+  markers_.resize(size);
+}
+
 void Tracks::RemoveMarkersForTrack(int track) {
   int size = 0;
   for (int i = 0; i < markers_.size(); ++i) {
@@ -136,16 +159,36 @@
   markers_.resize(size);
 }
 
+void Tracks::RemoveMarkersForCamera(int camera) {
+  int size = 0;
+  for (int i = 0; i < markers_.size(); ++i) {
+    if (markers_[i].camera != camera) {
+      markers_[size++] = markers_[i];
+    }
+  }
+  markers_.resize(size);
+}
+
 void Tracks::RemoveMarker(int image, int track) {
   int size = 0;
   for (int i = 0; i < markers_.size(); ++i) {
-    if (markers_[i].image != image || markers_[i].track != track) {
+    if (markers_[i].image != image ||
+        markers_[i].track != track) {
       markers_[size++] = markers_[i];
     }
   }
   markers_.resize(size);
 }
 
+int Tracks::CameraFromImage(int image) const {
+  for (int i = 0; i < markers_.size(); ++i) {
+    if (markers_[i].image == image) {
+      return markers_[i].camera;
+    }
+  }
+  return -1;
+}
+
 int Tracks::MaxImage() const {
   // TODO(MatthiasF): maintain a max_image_ member (updated on Insert)
   int max_image = 0;
@@ -164,6 +207,15 @@
   return max_track;
 }
 
+int Tracks::MaxCamera() const {
+  // TODO(MatthiasF): maintain a max_camera_ member (updated on Insert)
+  int max_camera = 0;
+  for (int i = 0; i < markers_.size(); ++i) {
+    max_camera = std::max(markers_[i].camera, max_camera);
+  }
+  return max_camera;
+}
+
 int Tracks::NumMarkers() const {
   return markers_.size();
 }
@@ -174,7 +226,7 @@
   vector<Vec2> coords;
   for (int i = 0; i < markers.size(); ++i) {
     const Marker &marker = markers[i];
-    if (markers[i].image == image) {
+    if (marker.image == image) {
       coords.push_back(Vec2(marker.x, marker.y));
     }
   }
diff -ru '--exclude=.svn' trunk/extern/libmv/libmv/simple_pipeline/tracks.h svn/extern/libmv/libmv/simple_pipeline/tracks.h
--- trunk/extern/libmv/libmv/simple_pipeline/tracks.h	2013-09-22 13:27:13.000000000 +0100
+++ svn/extern/libmv/libmv/simple_pipeline/tracks.h	2013-09-14 11:24:31.000000000 +0100
@@ -30,8 +30,11 @@
     A Marker is the 2D location of a tracked point in an image.
 
     \a x, \a y is the position of the marker in pixels from the top left corner
-    in the image identified by \a image. All markers for to the same target
-    form a track identified by a common \a track number.
+    of the image identified by \a image. All markers for the same target form a
+    track identified by a common \a track number. All markers for a single
+    \a image can be associated with a particular camera identified by \a camera.
+    Markers for a particular track but with different \a camera numbers
+    correspond to the same target filmed from an alternate viewpoint.
 
     \note Markers are typically aggregated with the help of the \l Tracks class.
 
@@ -41,6 +44,7 @@
   int image;
   int track;
   double x, y;
+  int camera;
 };
 
 /*!
@@ -67,29 +71,36 @@
   /*!
       Inserts a marker into the set. If there is already a marker for the given
       \a image and \a track, the existing marker is replaced. If there is no
-      marker for the given \a image and \a track, a new one is added.
+      marker for the given \a image and \a track, a new one is added. The marker
+      can be associated with a \a camera for use with multicamera reconsturction.
 
-      \a image and \a track are the keys used to retrieve the markers with the
-      other methods in this class.
+      \a camera, \a image and \a track are the keys used to retrieve the markers
+      with the other methods in this class.
 
       \note To get an identifier for a new track, use \l MaxTrack() + 1.
+      \note All markers for a single \a image should belong to the same
+            \a camera.
   */
-  void Insert(int image, int track, double x, double y);
+  void Insert(int image, int track, double x, double y, int camera = 0);
 
   /// Returns all the markers.
   vector<Marker> AllMarkers() const;
 
+  /// Returns all the markers visible in an \a image.
+  vector<Marker> MarkersInImage(int image) const;
+
   /// Returns all the markers belonging to a track.
   vector<Marker> MarkersForTrack(int track) const;
 
-  /// Returns all the markers visible in \a image.
-  vector<Marker> MarkersInImage(int image) const;
+  /// Returns all the markers visible from a \a camera.
+  vector<Marker> MarkersForCamera(int camera) const;
 
   /// Returns all the markers visible in \a image1 and \a image2.
   vector<Marker> MarkersInBothImages(int image1, int image2) const;
 
   /*!
-      Returns the markers in \a image1 and \a image2 which have a common track.
+      Returns the markers in \a image1 and \a image2 (both from \a camera) which
+      have a common track.
 
       This is not the same as the union of the markers in \a image1 and \a
       image2; each marker is for a track that appears in both images.
@@ -99,18 +110,30 @@
   /// Returns the marker in \a image belonging to \a track.
   Marker MarkerInImageForTrack(int image, int track) const;
 
+  /// Removes all the markers belonging to \a image.
+  void RemoveMarkersInImage(int image);
+
   /// Removes all the markers belonging to \a track.
   void RemoveMarkersForTrack(int track);
 
-  /// Removes the marker in \a image belonging to \a track.
+  /// Removes all the markers belonging to \a camera.
+  void RemoveMarkersForCamera(int camera);
+
+  /// Removes the marker in \a image of \a camera belonging to \a track.
   void RemoveMarker(int image, int track);
 
+  /// Returns the camera that \a image belongs to.
+  int CameraFromImage(int image) const;
+
   /// Returns the maximum image identifier used.
   int MaxImage() const;
 
   /// Returns the maximum track identifier used.
   int MaxTrack() const;
 
+  /// Returns the maximum camera identifier used.
+  int MaxCamera() const;
+
   /// Returns the number of markers.
   int NumMarkers() const;
 
